Decoder(3pm)

NAME
Audio::FLAC::Decoder - An object-oriented FLAC decoder

SYNOPSIS
  use Audio::FLAC::Decoder;
  my $decoder = Audio::FLAC::Decoder->open("song.flac");
  my $buffer;
  while ((my $len = $decoder->sysread($buffer) > 0) {
    # do something with the PCM stream
  }

  OR

  open FLAC, "song.flac" or die $!;
  my $decoder = Audio::FLAC::Decoder->open(\*FLAC);

  OR

  # can also be IO::Socket or any other IO::Handle subclass.
  my $fh = IO::Handle->new("song.flac");
  my $decoder = Audio::FLAC::Decoder->open($fh);

DESCRIPTION
This module provides users with Decoder objects for FLAC files. One can read data in PCM format from the stream, seek by pcm samples, or time.

CONSTRUCTOR

  "open ($filename)"
Opens an FLAC file for decoding. It opens a handle to the file or uses an existing handle and initializes all of the internal FLAC decoding structures. Note that the object will maintain open file descriptors until the object is collected by the garbage handler. Returns "undef" on failure.

INSTANCE METHODS

  "sysread ($buffer, [$size])"
Reads PCM data from the FLAC stream into $buffer. Returns the number of bytes read, 0 when it reaches the end of the stream, or a value less than 0 on error. The optional size can specify how many bytes to read.

  "raw_seek ($pos)"
Seeks through the compressed bitstream to the offset specified by $pos in raw bytes. Returns 0 on success.

  "sample_seek ($pos)"
Seeks through the bitstream to the offset specified by $pos in pcm samples. Returns 0 on success.

  "time_seek ($pos, [$page])"
Seeks through the bitstream to the offset specified by $pos in seconds. Returns 0 on success.

  "bitrate ([$stream])"
Returns the average bitrate for the specified logical bitstream. If $stream is left out or set to -1, the average bitrate for the entire stream will be reported.

  "time_total ([$stream])"
Returns the total number of seconds in the bitstream.

  "raw_tell ()"
Returns the current offset in bytes.

  "time_tell ()"
Returns the current offset in seconds. - NOT YET IMPLEMENTED

REQUIRES
libFLAC

COPYRIGHT
Copyright (c) 2004-2008, Dan Sully. All Rights Reserved.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

SEE ALSO
Audio::FLAC::Header